//
//  MyView.m
//  CIDemo
//
//  Created by Dave Dribin on 3/11/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "MyView.h"


@implementation MyView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        NSString * file = [[NSBundle mainBundle] pathForResource: @"image1" ofType: @"jpg"];
        mImage = [[CIImage alloc] initWithContentsOfURL: [NSURL fileURLWithPath: file]];

        mFilter = [[CIFilter filterWithName: @"CIExposureAdjust"] retain];
        [mFilter setDefaults];
        [mFilter setValue: mImage forKey: @"inputImage"];
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
    CIContext * context = [[NSGraphicsContext currentContext] CIContext];
    [mFilter setValue: [NSNumber numberWithFloat: mSliderValue]
               forKey: @"inputEV"];
    [context drawImage: [mFilter valueForKey: @"outputImage"]
               atPoint: CGPointZero fromRect: [mImage extent]];
}

- (IBAction) sliderChanged: (id) sender;
{
    mSliderValue = [sender floatValue];
    [self setNeedsDisplay: YES];
}

@end
