//
//  MyView.m
//  CIDemo
//
//  Created by Dave Dribin on 3/11/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "MyView.h"

@interface MyAnimation : NSAnimation {}
@end

@implementation MyAnimation

- (void)setCurrentProgress:(NSAnimationProgress)progress
{
    [super setCurrentProgress: progress];
    [[self delegate] setNeedsDisplay: YES];
}

@end

@implementation MyView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        NSString * file = [[NSBundle mainBundle] pathForResource: @"image1" ofType: @"jpg"];
        mImage = [[CIImage alloc] initWithContentsOfURL: [NSURL fileURLWithPath: file]];

        file = [[NSBundle mainBundle] pathForResource: @"image2" ofType: @"jpg"];
        mImage2 = [[CIImage alloc] initWithContentsOfURL: [NSURL fileURLWithPath: file]];

        mFilter = [[CIFilter filterWithName: @"CIDissolveTransition"] retain];
        [mFilter setDefaults];
        [mFilter setValue: mImage forKey: @"inputImage"];
        [mFilter setValue: mImage2 forKey: @"inputTargetImage"];
        
        mAnimation = [[MyAnimation alloc] initWithDuration: .5
                                            animationCurve: NSAnimationLinear];
        [mAnimation setDelegate: self];
        [mAnimation setAnimationBlockingMode: NSAnimationNonblocking];
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
    CIContext * context = [[NSGraphicsContext currentContext] CIContext];
    [mFilter setValue: [NSNumber numberWithFloat: [mAnimation currentValue]]
               forKey: @"inputTime"];
    [context drawImage: [mFilter valueForKey: @"outputImage"]
               atPoint: CGPointZero fromRect: [mImage extent]];
}

- (IBAction) startTransition: (id) sender;
{
    [mAnimation startAnimation];
}

@end
