//
//  MyView.m
//  CIDemo
//
//  Created by Dave Dribin on 3/11/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "MyView.h"

#include <math.h>
static inline double radians (double degrees) {return degrees * M_PI/180;}

@interface MyAnimation : NSAnimation {}
@end

@implementation MyAnimation

- (void)setCurrentProgress:(NSAnimationProgress)progress
{
    [super setCurrentProgress: progress];
    [[self delegate] setNeedsDisplay: YES];
}

@end

@implementation MyView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        NSString * file = [[NSBundle mainBundle] pathForResource: @"image1" ofType: @"jpg"];
        mImage = [[CIImage alloc] initWithContentsOfURL: [NSURL fileURLWithPath: file]];

        file = [[NSBundle mainBundle] pathForResource: @"image2" ofType: @"jpg"];
        mImage2 = [[CIImage alloc] initWithContentsOfURL: [NSURL fileURLWithPath: file]];

        mFilter = [[CIFilter filterWithName: @"CICopyMachineTransition"] retain];
        [mFilter setDefaults];
        [mFilter setValue: mImage forKey: @"inputImage"];
        [mFilter setValue: mImage2 forKey: @"inputTargetImage"];
        [mFilter setValue: [CIColor colorWithRed:.6 green:1 blue:.8 alpha:1] forKey: @"inputColor"];
        CGRect extent = [mImage extent];
        CIVector * inputExtent = [CIVector vectorWithX: 0 Y: 0 
                                                     Z: extent.size.width
                                                     W: extent.size.height];
        [mFilter setValue: inputExtent
                   forKey: @"inputExtent"];
        [mFilter setValue: [NSNumber numberWithFloat: radians(0.0)]
                   forKey: @"inputAngle"];
        [mFilter setValue: [NSNumber numberWithFloat: 100]
                   forKey: @"inputWidth"];
        [mFilter setValue: [NSNumber numberWithFloat: 1.0]
                   forKey: @"inputOpacity"];

        mAnimation = [[MyAnimation alloc] initWithDuration: 2.0
                                            animationCurve: NSAnimationLinear];
        [mAnimation setDelegate: self];
        [mAnimation setAnimationBlockingMode: NSAnimationNonblocking];
        
    }
    return self;
}

- (void)drawRect:(NSRect)rect {
    CIContext * context = [[NSGraphicsContext currentContext] CIContext];
    [mFilter setValue: [NSNumber numberWithFloat: [mAnimation currentValue]]
               forKey: @"inputTime"];
    [context drawImage: [mFilter valueForKey: @"outputImage"]
               atPoint: CGPointZero fromRect: [mImage extent]];
}

- (IBAction) startTransition: (id) sender;
{
    [mAnimation startAnimation];
}

@end
