//
//  MyFlipFilter.m
//  CIDemo
//
//  Created by Dave Dribin on 3/12/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "MyFlipFilter.h"

static CIKernel * sFlipKernel = nil;

@implementation MyFlipFilter

+ (void)initialize
{
    [CIFilter registerFilterName: @"MyFlipFilter"  constructor: self
                 classAttributes: [NSDictionary dictionaryWithObjectsAndKeys:
                     
                     @"Vertical Flip",                      kCIAttributeFilterDisplayName,
                     
                     [NSArray arrayWithObjects:
                         kCICategoryGeometryAdjustment, kCICategoryVideo, kCICategoryStillImage,
                         kCICategoryInterlaced, kCICategoryNonSquarePixels,
                         nil],                              kCIAttributeFilterCategories,
                                          
                     nil]];
}

+ (CIFilter *)filterWithName: (NSString *)name
{
    CIFilter  *filter;
    
    filter = [[self alloc] init];
    return [filter autorelease];
}

- (id)init
{
    if(sFlipKernel == nil)
    {
        NSBundle * bundle = [NSBundle bundleForClass: [self class]];
        NSString * code = [NSString stringWithContentsOfFile:
            [bundle pathForResource: @"MyFlip" ofType: @"cikernel"]];
        NSArray * kernels = [CIKernel kernelsWithString: code];
        
        sFlipKernel = [[kernels objectAtIndex:0] retain];
    }
    
    return [super init];
}


- (CIImage *)outputImage;
{
    CISampler * image = [CISampler samplerWithImage: inputImage];
    
    return [self apply: sFlipKernel, image,
        kCIApplyOptionDefinition, [image definition], nil];
}


@end
